
public class ReadWriteLock {
	private int readers = 0;
	private boolean writing = false;

	public synchronized void acquireRead() throws InterruptedException {
		while (this.writing) {
			this.wait();
		}
		++this.readers;
		// this.notifyAll(); // nicht ntig
	}

	public synchronized void releaseRead() {
		--this.readers;
		if (this.readers == 0) {
			this.notifyAll();
		}
	}

	public synchronized void acquireWrite()
			throws InterruptedException {
		while (this.readers > 0 || this.writing) {
			this.wait();
		}
		this.writing = true;
		// this.notifyAll(); // nicht ntig
	}

	public synchronized void releaseWrite() {
		this.writing = false;
		this.notifyAll();
	}
}
